Antiprism 0.23

- Main Page
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions

# geom_disp Class Reference

Base class for displaying a geometry. More...

`#include <scene.h>`

Inherited by disp_poly`[virtual]`, and geom_disp_label`[virtual]`.

Collaboration diagram for geom_disp:
[legend]

List of all members.

## Public Types
enum | { , rad_ball = -1 }
| The scene geometry to be displaed. More...
## Public Member Functions
| geom_disp ()
| Constructor.
elem_disp & | v ()
| Get a reference to the basic vertex properties.
const elem_disp & | v () const
| Get a reference to the basic vertex properties.
elem_disp & | e ()
| Get a reference to the basic edge properties.
const elem_disp & | e () const
| Get a reference to the basic edge properties.
elem_disp & | f ()
| Get a reference to the basic face properties.
const elem_disp & | f () const
| Get a reference to the basic face properties.
double | get_edge_rad () const
| Get the edge rod radius.
double | get_vert_rad () const
| Get the vertex ball radius.
void | set_elem_trans (bool trans)
| Set display of transparency.
bool | get_elem_trans ()
| Get display of transparency.
virtual vec3d | get_label_pos (const vec3d &point, double elem_sz)
| Position of a label for a point.
virtual vec3d | get_v_label_pos (int idx)
| Position of a vertex label.
virtual vec3d | get_e_label_pos (int idx)
| Position of an edge label.
virtual vec3d | get_f_label_pos (int idx)
| Position of a face label.
void | set_scene_geom (scene_geom *sc_geo)
| Set the scene geometry to display.
virtual geom_disp * | clone () const =0
| Clone.
virtual void | geom_changed ()=0
| Action performed when the geometry has changed.
virtual void | vrml_geom (FILE *ofile, const scene &scene, int sig_dgts)=0
| Write geometry for inclusion in VRML.
virtual void | pov_geom (FILE *ofile, const scene &scene, int sig_dgts)=0
| Write geometry for inclusion in a POV-Ray script.
virtual void | gl_geom (const scene &scen)
| Display geometry as OpenGL.
virtual int | animate ()
| Update animated properties.

## Detailed Description

Base class for displaying a geometry.

## Member Enumeration Documentation

anonymous enum

The scene geometry to be displaed.

Enumerator:

  rad_ball | Default radius.

## Member Function Documentation

virtual int geom_disp::animate | ( |  | ) | `[inline, virtual]`

Update animated properties.

Returns:
  The number of animation changes (`0` if no changes).

virtual geom_disp* geom_disp::clone | ( |  | ) | const`[pure virtual]`

Clone.

Returns:
  A dynamically allocated copy of the object.

const elem_disp& geom_disp::e | ( |  | ) | const`[inline]`

Get a reference to the basic edge properties.

Returns:
  A reference to the proprties.

elem_disp& geom_disp::e | ( |  | ) | `[inline]`

Get a reference to the basic edge properties.

Returns:
  A reference to the proprties.

elem_disp& geom_disp::f | ( |  | ) | `[inline]`

Get a reference to the basic face properties.

Returns:
  A reference to the proprties.

const elem_disp& geom_disp::f | ( |  | ) | const`[inline]`

Get a reference to the basic face properties.

Returns:
  A reference to the proprties.

vec3d geom_disp::get_e_label_pos | ( | int | idx | ) | `[virtual]`

Position of an edge label.

Parameters:

  idx | edge index number.

Returns:
  position of the label

double geom_disp::get_edge_rad | ( |  | ) | const

Get the edge rod radius.

Returns:
  The edge rod radius.

bool geom_disp::get_elem_trans | ( |  | ) | `[inline]`

Get display of transparency.

Returns:
  `true` if transparency will be displayed, `false` if transparency is displayed as solid.

vec3d geom_disp::get_f_label_pos | ( | int | idx | ) | `[virtual]`

Position of a face label.

Parameters:

  idx | face index number.

Returns:
  position of the label

vec3d geom_disp::get_label_pos | ( | const vec3d & | point,
|  | double | elem_sz
| ) |  | `[virtual]`

Position of a label for a point.

Parameters:

  point | the point to be labelled.
  elem_sz | the size of the element.

Returns:
  The position of the label.

vec3d geom_disp::get_v_label_pos | ( | int | idx | ) | `[virtual]`

Position of a vertex label.

Parameters:

  idx | vertex index number.

Returns:
  position of the label

double geom_disp::get_vert_rad | ( |  | ) | const

Get the vertex ball radius.

Returns:
  The vertex ball radius.

void geom_disp::gl_geom | ( | const scene & | scen | ) | `[inline, virtual]`

Display geometry as OpenGL.

Parameters:

  scen | the scene that the display is part of.

virtual void geom_disp::pov_geom | ( | FILE * | ofile,
|  | const scene & | scene,
|  | int | sig_dgts
| ) |  | `[pure virtual]`

Write geometry for inclusion in a POV-Ray script.

Parameters:

  ofile | file pointer to write to.
  scene | the scene that the display is part of.
  sig_dgts | the number of significant digits for the output.

void geom_disp::set_elem_trans | ( | bool | trans | ) | `[inline]`

Set display of transparency.

Parameters:

  trans | `true` to display any transparency, `false` to display as solid.

void geom_disp::set_scene_geom | ( | scene_geom * | sc_geo | ) | `[inline]`

Set the scene geometry to display.

Parameters:

  sc_geo | the scene geometry to display.

const elem_disp& geom_disp::v | ( |  | ) | const`[inline]`

Get a reference to the basic vertex properties.

Returns:
  A reference to the proprties.

elem_disp& geom_disp::v | ( |  | ) | `[inline]`

Get a reference to the basic vertex properties.

Returns:
  A reference to the proprties.

virtual void geom_disp::vrml_geom | ( | FILE * | ofile,
|  | const scene & | scene,
|  | int | sig_dgts
| ) |  | `[pure virtual]`

Write geometry for inclusion in VRML.

Parameters:

  ofile | file pointer to write to.
  scene | the scene that the display is part of.
  sig_dgts | the number of significant digits for the output.

The documentation for this class was generated from the following files:

- base/scene.h
- base/scene.cc